diff --git a/rsvg-filter.c b/rsvg-filter.c
index 705f14c..81cce75 100644
--- a/rsvg-filter.c
+++ b/rsvg-filter.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /* 
    rsvg-filter.c: Provides filters
  
@@ -29,6 +30,8 @@
 #include "rsvg-styles.h"
 #include "rsvg-image.h"
 #include "rsvg-css.h"
+#include "rsvg-cairo-render.h"
+
 #include <string.h>
 
 #include <math.h>
@@ -40,12 +43,8 @@
 typedef struct _RsvgFilterPrimitiveOutput RsvgFilterPrimitiveOutput;
 
 struct _RsvgFilterPrimitiveOutput {
-    GdkPixbuf *result;
+    cairo_surface_t *surface;
     RsvgIRect bounds;
-    gboolean Rused;
-    gboolean Gused;
-    gboolean Bused;
-    gboolean Aused;
 };
 
 typedef struct _RsvgFilterContext RsvgFilterContext;
@@ -54,17 +53,45 @@ struct _RsvgFilterContext {
     gint width, height;
     RsvgFilter *filter;
     GHashTable *results;
-    GdkPixbuf *source;
-    GdkPixbuf *bg;
+    cairo_surface_t *source_surface;
+    cairo_surface_t *bg_surface;
     RsvgFilterPrimitiveOutput lastresult;
-    double affine[6];
-    double paffine[6];
+    cairo_matrix_t affine;
+    cairo_matrix_t paffine;
     int channelmap[4];
     RsvgDrawingCtx *ctx;
 };
 
 typedef struct _RsvgFilterPrimitive RsvgFilterPrimitive;
 
+/* We don't have real subclassing here.  If you derive something from
+ * RsvgFilterPrimitive, and don't need any special code to free your
+ * RsvgFilterPrimitiveFoo structure, you can just set
+ *
+ *    foo_filter->super.super.free = rsvg_filter_primitive_free;
+ *
+ * for the destructor.  Otherwise, create a custom destructor like this:
+ *
+ *    foo_filter->super.super.free = &rsvg_filter_primitive_foo_free;
+ *
+ *    ...
+ *
+ *    static void
+ *    rsvg_filter_primitive_foo_free (RsvgNode *self)
+ *    {
+ *        RsvgFilterPrimitiveFoo *foo;
+ *
+ *        foo = (RsvgFilterPrimitiveFoo *) self;
+ *        g_free (foo->my_custom_stuff);
+ *        g_free (foo->more_custom_stuff);
+ *        ... etc ...
+ *
+ *        rsvg_filter_primitive_free (self);
+ *    }
+ *
+ * That last call to rsvg_filter_primitive_free() will free the base RsvgFilterPrimitive's own fields,
+ * and your whole structure itself, via _rsvg_node_free().
+ */
 struct _RsvgFilterPrimitive {
     RsvgNode super;
     RsvgLength x, y, width, height;
@@ -78,6 +105,18 @@ struct _RsvgFilterPrimitive {
 /*************************************************************/
 
 static void
+rsvg_filter_primitive_free (RsvgNode *self)
+{
+    RsvgFilterPrimitive *primitive;
+
+    primitive = (RsvgFilterPrimitive *) self;
+    g_string_free (primitive->in, TRUE);
+    g_string_free (primitive->result, TRUE);
+
+    _rsvg_node_free (self);
+}
+
+static void
 rsvg_filter_primitive_render (RsvgFilterPrimitive * self, RsvgFilterContext * ctx)
 {
     self->render (self, ctx);
@@ -87,18 +126,18 @@ static RsvgIRect
 rsvg_filter_primitive_get_bounds (RsvgFilterPrimitive * self, RsvgFilterContext * ctx)
 {
     RsvgBbox box, otherbox;
-    double affine[6];
+    cairo_matrix_t affine;
 
-    _rsvg_affine_identity (affine);
-    rsvg_bbox_init (&box, affine);
-    rsvg_bbox_init (&otherbox, ctx->affine);
+    cairo_matrix_init_identity (&affine);
+    rsvg_bbox_init (&box, &affine);
+    rsvg_bbox_init (&otherbox, &ctx->affine);
     otherbox.virgin = 0;
     if (ctx->filter->filterunits == objectBoundingBox)
         _rsvg_push_view_box (ctx->ctx, 1., 1.);
-    otherbox.x = _rsvg_css_normalize_length (&ctx->filter->x, ctx->ctx, 'h');
-    otherbox.y = _rsvg_css_normalize_length (&ctx->filter->y, ctx->ctx, 'v');
-    otherbox.w = _rsvg_css_normalize_length (&ctx->filter->width, ctx->ctx, 'h');
-    otherbox.h = _rsvg_css_normalize_length (&ctx->filter->height, ctx->ctx, 'v');
+    otherbox.rect.x = _rsvg_css_normalize_length (&ctx->filter->x, ctx->ctx, 'h');
+    otherbox.rect.y = _rsvg_css_normalize_length (&ctx->filter->y, ctx->ctx, 'v');
+    otherbox.rect.width = _rsvg_css_normalize_length (&ctx->filter->width, ctx->ctx, 'h');
+    otherbox.rect.height = _rsvg_css_normalize_length (&ctx->filter->height, ctx->ctx, 'v');
     if (ctx->filter->filterunits == objectBoundingBox)
         _rsvg_pop_view_box (ctx->ctx);
 
@@ -108,68 +147,69 @@ rsvg_filter_primitive_get_bounds (RsvgFilterPrimitive * self, RsvgFilterContext
         if (self->x.factor != 'n' || self->y.factor != 'n' ||
             self->width.factor != 'n' || self->height.factor != 'n') {
 
-            rsvg_bbox_init (&otherbox, ctx->paffine);
+            rsvg_bbox_init (&otherbox, &ctx->paffine);
             otherbox.virgin = 0;
             if (ctx->filter->primitiveunits == objectBoundingBox)
                 _rsvg_push_view_box (ctx->ctx, 1., 1.);
             if (self->x.factor != 'n')
-                otherbox.x = _rsvg_css_normalize_length (&self->x, ctx->ctx, 'h');
+                otherbox.rect.x = _rsvg_css_normalize_length (&self->x, ctx->ctx, 'h');
             else
-                otherbox.x = 0;
+                otherbox.rect.x = 0;
             if (self->y.factor != 'n')
-                otherbox.y = _rsvg_css_normalize_length (&self->y, ctx->ctx, 'v');
+                otherbox.rect.y = _rsvg_css_normalize_length (&self->y, ctx->ctx, 'v');
             else
-                otherbox.y = 0;
+                otherbox.rect.y = 0;
             if (self->width.factor != 'n')
-                otherbox.w = _rsvg_css_normalize_length (&self->width, ctx->ctx, 'h');
+                otherbox.rect.width = _rsvg_css_normalize_length (&self->width, ctx->ctx, 'h');
             else
-                otherbox.w = ctx->ctx->vb.w;
+                otherbox.rect.width = ctx->ctx->vb.rect.width;
             if (self->height.factor != 'n')
-                otherbox.h = _rsvg_css_normalize_length (&self->height, ctx->ctx, 'v');
+                otherbox.rect.height = _rsvg_css_normalize_length (&self->height, ctx->ctx, 'v');
             else
-                otherbox.h = ctx->ctx->vb.h;
+                otherbox.rect.height = ctx->ctx->vb.rect.height;
             if (ctx->filter->primitiveunits == objectBoundingBox)
                 _rsvg_pop_view_box (ctx->ctx);
             rsvg_bbox_clip (&box, &otherbox);
         }
 
-    rsvg_bbox_init (&otherbox, affine);
+    rsvg_bbox_init (&otherbox, &affine);
     otherbox.virgin = 0;
-    otherbox.x = 0;
-    otherbox.y = 0;
-    otherbox.w = ctx->width;
-    otherbox.h = ctx->height;
+    otherbox.rect.x = 0;
+    otherbox.rect.y = 0;
+    otherbox.rect.width = ctx->width;
+    otherbox.rect.height = ctx->height;
     rsvg_bbox_clip (&box, &otherbox);
     {
-        RsvgIRect output = { box.x, box.y,
-            box.x + box.w,
-            box.y + box.h
+        RsvgIRect output = { box.rect.x, box.rect.y,
+            box.rect.x + box.rect.width,
+            box.rect.y + box.rect.height
         };
         return output;
     }
 }
 
-GdkPixbuf *
-_rsvg_pixbuf_new_cleared (GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample,
-                          int width, int height)
+static cairo_surface_t *
+_rsvg_image_surface_new (int width, int height)
 {
-    GdkPixbuf *pb;
-    guchar *data;
+    cairo_surface_t *surface;
 
-    pb = gdk_pixbuf_new (colorspace, has_alpha, bits_per_sample, width, height);
-    data = gdk_pixbuf_get_pixels (pb);
-    memset (data, 0, width * height * 4);
+    surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
+    if (cairo_surface_status (surface) != CAIRO_STATUS_SUCCESS) {
+      cairo_surface_destroy (surface);
+      return NULL;
+    }
 
-    return pb;
+    return surface;
 }
 
 static guchar
-gdk_pixbuf_get_interp_pixel (guchar * src, gdouble ox, gdouble oy, guchar ch, RsvgIRect boundarys,
+get_interp_pixel (guchar * src, gdouble ox, gdouble oy, guchar ch, RsvgIRect boundarys,
                              guint rowstride)
 {
     double xmod, ymod;
     double dist1, dist2, dist3, dist4;
     double c, c1, c2, c3, c4;
+    double fox, foy, cox, coy;
 
     xmod = fmod (ox, 1.0);
     ymod = fmod (oy, 1.0);
@@ -179,29 +219,34 @@ gdk_pixbuf_get_interp_pixel (guchar * src, gdouble ox, gdouble oy, guchar ch, Rs
     dist3 = (xmod) * (ymod);
     dist4 = (1 - xmod) * (ymod);
 
-    if (floor (ox) <= boundarys.x0 || floor (ox) >= boundarys.x1 ||
-        floor (oy) <= boundarys.y0 || floor (oy) >= boundarys.y1)
+    fox = floor (ox);
+    foy = floor (oy);
+    cox = ceil (ox);
+    coy = ceil (oy);
+
+    if (fox <= boundarys.x0 || fox >= boundarys.x1 ||
+        foy <= boundarys.y0 || foy >= boundarys.y1)
         c1 = 0;
     else
-        c1 = src[(guint) floor (oy) * rowstride + (guint) floor (ox) * 4 + ch];
+        c1 = src[(guint) foy * rowstride + (guint) fox * 4 + ch];
 
-    if (ceil (ox) <= boundarys.x0 || ceil (ox) >= boundarys.x1 ||
-        floor (oy) <= boundarys.y0 || floor (oy) >= boundarys.y1)
+    if (cox <= boundarys.x0 || cox >= boundarys.x1 ||
+        foy <= boundarys.y0 || foy >= boundarys.y1)
         c2 = 0;
     else
-        c2 = src[(guint) floor (oy) * rowstride + (guint) ceil (ox) * 4 + ch];
+        c2 = src[(guint) foy * rowstride + (guint) cox * 4 + ch];
 
-    if (ceil (ox) <= boundarys.x0 || ceil (ox) >= boundarys.x1 ||
-        ceil (oy) <= boundarys.y0 || ceil (oy) >= boundarys.y1)
+    if (cox <= boundarys.x0 || cox >= boundarys.x1 ||
+        coy <= boundarys.y0 || coy >= boundarys.y1)
         c3 = 0;
     else
-        c3 = src[(guint) ceil (oy) * rowstride + (guint) ceil (ox) * 4 + ch];
+        c3 = src[(guint) coy * rowstride + (guint) cox * 4 + ch];
 
-    if (floor (ox) <= boundarys.x0 || floor (ox) >= boundarys.x1 ||
-        ceil (oy) <= boundarys.y0 || ceil (oy) >= boundarys.y1)
+    if (fox <= boundarys.x0 || fox >= boundarys.x1 ||
+        coy <= boundarys.y0 || coy >= boundarys.y1)
         c4 = 0;
     else
-        c4 = src[(guint) ceil (oy) * rowstride + (guint) floor (ox) * 4 + ch];
+        c4 = src[(guint) coy * rowstride + (guint) fox * 4 + ch];
 
     c = (c1 * dist1 + c2 * dist2 + c3 * dist3 + c4 * dist4) / (dist1 + dist2 + dist3 + dist4);
 
@@ -209,116 +254,110 @@ gdk_pixbuf_get_interp_pixel (guchar * src, gdouble ox, gdouble oy, guchar ch, Rs
 }
 
 static void
-rsvg_filter_fix_coordinate_system (RsvgFilterContext * ctx, RsvgState * state, RsvgBbox bbox)
+rsvg_filter_fix_coordinate_system (RsvgFilterContext * ctx, RsvgState * state, RsvgBbox *bbox)
 {
     int x, y, height, width;
-    int i;
 
-    x = bbox.x;
-    y = bbox.y;
-    width = bbox.w;
-    height = bbox.h;
+    x = bbox->rect.x;
+    y = bbox->rect.y;
+    width = bbox->rect.width;
+    height = bbox->rect.height;
 
-    ctx->width = gdk_pixbuf_get_width (ctx->source);
-    ctx->height = gdk_pixbuf_get_height (ctx->source);
+    ctx->width = cairo_image_surface_get_width (ctx->source_surface);
+    ctx->height = cairo_image_surface_get_height (ctx->source_surface);
 
-    for (i = 0; i < 6; i++)
-        ctx->affine[i] = state->affine[i];
+    ctx->affine = state->affine;
     if (ctx->filter->filterunits == objectBoundingBox) {
-        double affine[6] = { width, 0, 0, height, x, y };
-        _rsvg_affine_multiply (ctx->affine, affine, ctx->affine);
+        cairo_matrix_t affine;
+        cairo_matrix_init (&affine, width, 0, 0, height, x, y);
+        cairo_matrix_multiply (&ctx->affine, &affine, &ctx->affine);
     }
-    for (i = 0; i < 6; i++)
-        ctx->paffine[i] = state->affine[i];
+    ctx->paffine = state->affine;
     if (ctx->filter->primitiveunits == objectBoundingBox) {
-        double affine[6] = { width, 0, 0, height, x, y };
-        _rsvg_affine_multiply (ctx->paffine, affine, ctx->paffine);
+        cairo_matrix_t affine;
+        cairo_matrix_init (&affine, width, 0, 0, height, x, y);
+        cairo_matrix_multiply (&ctx->paffine, &affine, &ctx->paffine);
     }
 }
 
-void
-rsvg_alpha_blt (GdkPixbuf * src, gint srcx, gint srcy, gint srcwidth,
-                gint srcheight, GdkPixbuf * dst, gint dstx, gint dsty)
+static gboolean
+rectangle_intersect (gint ax, gint ay, gint awidth, gint aheight,
+                     gint bx, gint by, gint bwidth, gint bheight,
+                     gint *rx, gint *ry, gint *rwidth, gint *rheight)
 {
-    gint rightx;
-    gint bottomy;
-    gint dstwidth;
-    gint dstheight;
+    gint rx1, ry1, rx2, ry2;
+
+    rx1 = MAX (ax, bx);
+    ry1 = MAX (ay, by);
+    rx2 = MIN (ax + awidth, bx + bwidth);
+    ry2 = MIN (ay + aheight, by + bheight);
+
+    if (rx2 > rx1 && ry2 > ry1) {
+        *rx = rx1;
+        *ry = ry1;
+        *rwidth = rx2 - rx1;
+        *rheight = ry2 - ry1;
 
-    gint srcoffsetx;
-    gint srcoffsety;
-    gint dstoffsetx;
-    gint dstoffsety;
+        return TRUE;
+    } else {
+        *rx = *ry = *rwidth = *rheight = 0;
+
+        return FALSE;
+    }
+}
 
+static void
+rsvg_alpha_blt (cairo_surface_t *src,
+                gint srcx,
+                gint srcy,
+                gint srcwidth,
+                gint srcheight,
+                cairo_surface_t *dst,
+                gint dstx,
+                gint dsty)
+{
+    gint src_surf_width, src_surf_height;
+    gint dst_surf_width, dst_surf_height;
+    gint src_clipped_x, src_clipped_y, src_clipped_width, src_clipped_height;
+    gint dst_clipped_x, dst_clipped_y, dst_clipped_width, dst_clipped_height;
     gint x, y, srcrowstride, dstrowstride, sx, sy, dx, dy;
     guchar *src_pixels, *dst_pixels;
 
-    dstheight = srcheight;
-    dstwidth = srcwidth;
-
-    rightx = srcx + srcwidth;
-    bottomy = srcy + srcheight;
-
-    if (rightx > gdk_pixbuf_get_width (src))
-        rightx = gdk_pixbuf_get_width (src);
-    if (bottomy > gdk_pixbuf_get_height (src))
-        bottomy = gdk_pixbuf_get_height (src);
-    srcwidth = rightx - srcx;
-    srcheight = bottomy - srcy;
-
-    rightx = dstx + dstwidth;
-    bottomy = dsty + dstheight;
-    if (rightx > gdk_pixbuf_get_width (dst))
-        rightx = gdk_pixbuf_get_width (dst);
-    if (bottomy > gdk_pixbuf_get_height (dst))
-        bottomy = gdk_pixbuf_get_height (dst);
-    dstwidth = rightx - dstx;
-    dstheight = bottomy - dsty;
-
-    if (dstwidth < srcwidth)
-        srcwidth = dstwidth;
-    if (dstheight < srcheight)
-        srcheight = dstheight;
-
-    if (srcx < 0)
-        srcoffsetx = 0 - srcx;
-    else
-        srcoffsetx = 0;
+    g_assert (cairo_image_surface_get_format (src) == CAIRO_FORMAT_ARGB32);
+    g_assert (cairo_image_surface_get_format (dst) == CAIRO_FORMAT_ARGB32);
 
-    if (srcy < 0)
-        srcoffsety = 0 - srcy;
-    else
-        srcoffsety = 0;
+    cairo_surface_flush (src);
 
-    if (dstx < 0)
-        dstoffsetx = 0 - dstx;
-    else
-        dstoffsetx = 0;
+    src_surf_width  = cairo_image_surface_get_width (src);
+    src_surf_height = cairo_image_surface_get_height (src);
 
-    if (dsty < 0)
-        dstoffsety = 0 - dsty;
-    else
-        dstoffsety = 0;
+    dst_surf_width  = cairo_image_surface_get_width (dst);
+    dst_surf_height = cairo_image_surface_get_height (dst);
+
+    if (!rectangle_intersect (0, 0, src_surf_width, src_surf_height,
+                              srcx, srcy, srcwidth, srcheight,
+                              &src_clipped_x, &src_clipped_y, &src_clipped_width, &src_clipped_height))
+        return; /* source rectangle is not in source surface */
 
-    if (dstoffsetx > srcoffsetx)
-        srcoffsetx = dstoffsetx;
-    if (dstoffsety > srcoffsety)
-        srcoffsety = dstoffsety;
+    if (!rectangle_intersect (0, 0, dst_surf_width, dst_surf_height,
+                              dstx, dsty, src_clipped_width, src_clipped_height,
+                              &dst_clipped_x, &dst_clipped_y, &dst_clipped_width, &dst_clipped_height))
+        return; /* dest rectangle is not in dest surface */
 
-    srcrowstride = gdk_pixbuf_get_rowstride (src);
-    dstrowstride = gdk_pixbuf_get_rowstride (dst);
+    srcrowstride = cairo_image_surface_get_stride (src);
+    dstrowstride = cairo_image_surface_get_stride (dst);
 
-    src_pixels = gdk_pixbuf_get_pixels (src);
-    dst_pixels = gdk_pixbuf_get_pixels (dst);
+    src_pixels = cairo_image_surface_get_data (src);
+    dst_pixels = cairo_image_surface_get_data (dst);
 
-    for (y = srcoffsety; y < srcheight; y++)
-        for (x = srcoffsetx; x < srcwidth; x++) {
+    for (y = 0; y < dst_clipped_height; y++)
+        for (x = 0; x < dst_clipped_width; x++) {
             guint a, c, ad, cd, ar, cr, i;
 
-            sx = x + srcx;
-            sy = y + srcy;
-            dx = x + dstx;
-            dy = y + dsty;
+            sx = x + src_clipped_x;
+            sy = y + src_clipped_y;
+            dx = x + dst_clipped_x;
+            dy = y + dst_clipped_y;
             a = src_pixels[4 * sx + sy * srcrowstride + 3];
 
             if (a) {
@@ -333,15 +372,18 @@ rsvg_alpha_blt (GdkPixbuf * src, gint srcx, gint srcy, gint srcwidth,
                 }
             }
         }
+
+    cairo_surface_mark_dirty (dst);
 }
 
-void
-rsvg_art_affine_image (const GdkPixbuf * img, GdkPixbuf * intermediate,
-                       double *affine, double w, double h)
+static gboolean
+rsvg_art_affine_image (cairo_surface_t *img, 
+                       cairo_surface_t *intermediate,
+                       cairo_matrix_t *affine, 
+                       double w, 
+                       double h)
 {
-    gdouble tmp_affine[6];
-    gdouble inv_affine[6];
-    gdouble raw_inv_affine[6];
+    cairo_matrix_t inv_affine, raw_inv_affine;
     gint intstride;
     gint basestride;
     gint basex, basey;
@@ -356,41 +398,43 @@ rsvg_art_affine_image (const GdkPixbuf * img, GdkPixbuf * intermediate,
     gint iwidth, iheight;
     gint width, height;
 
-    width = gdk_pixbuf_get_width (img);
-    height = gdk_pixbuf_get_height (img);
-    iwidth = gdk_pixbuf_get_width (intermediate);
-    iheight = gdk_pixbuf_get_height (intermediate);
+    g_assert (cairo_image_surface_get_format (intermediate) == CAIRO_FORMAT_ARGB32);
 
-    has_alpha = gdk_pixbuf_get_has_alpha (img);
+    cairo_surface_flush (img);
 
-    basestride = gdk_pixbuf_get_rowstride (img);
-    intstride = gdk_pixbuf_get_rowstride (intermediate);
-    basepix = gdk_pixbuf_get_pixels (img);
-    intpix = gdk_pixbuf_get_pixels (intermediate);
-    basebpp = has_alpha ? 4 : 3;
+    width = cairo_image_surface_get_width (img);
+    height = cairo_image_surface_get_height (img);
+    iwidth = cairo_image_surface_get_width (intermediate);
+    iheight = cairo_image_surface_get_height (intermediate);
 
-    _rsvg_affine_invert (raw_inv_affine, affine);
+    has_alpha = cairo_image_surface_get_format (img) == CAIRO_FORMAT_ARGB32;
 
-    /*scale to w and h */
-    tmp_affine[0] = (double) w;
-    tmp_affine[3] = (double) h;
-    tmp_affine[1] = tmp_affine[2] = tmp_affine[4] = tmp_affine[5] = 0;
-    _rsvg_affine_multiply (tmp_affine, tmp_affine, affine);
+    basestride = cairo_image_surface_get_stride (img);
+    intstride = cairo_image_surface_get_stride (intermediate);
+    basepix = cairo_image_surface_get_data (img);
+    intpix = cairo_image_surface_get_data (intermediate);
+    basebpp = has_alpha ? 4 : 3;
 
-    _rsvg_affine_invert (inv_affine, tmp_affine);
+    raw_inv_affine = *affine;
+    if (cairo_matrix_invert (&raw_inv_affine) != CAIRO_STATUS_SUCCESS)
+      return FALSE;
 
+    cairo_matrix_init_scale (&inv_affine, w, h);
+    cairo_matrix_multiply (&inv_affine, &inv_affine, affine);
+    if (cairo_matrix_invert (&inv_affine) != CAIRO_STATUS_SUCCESS)
+      return FALSE;
 
     /*apply the transformation */
     for (i = 0; i < iwidth; i++)
         for (j = 0; j < iheight; j++) {
-            fbasex = (inv_affine[0] * (double) i + inv_affine[2] * (double) j +
-                      inv_affine[4]) * (double) width;
-            fbasey = (inv_affine[1] * (double) i + inv_affine[3] * (double) j +
-                      inv_affine[5]) * (double) height;
+            fbasex = (inv_affine.xx * (double) i + inv_affine.xy * (double) j +
+                      inv_affine.x0) * (double) width;
+            fbasey = (inv_affine.yx * (double) i + inv_affine.yy * (double) j +
+                      inv_affine.y0) * (double) height;
             basex = floor (fbasex);
             basey = floor (fbasey);
-            rawx = raw_inv_affine[0] * i + raw_inv_affine[2] * j + raw_inv_affine[4];
-            rawy = raw_inv_affine[1] * i + raw_inv_affine[3] * j + raw_inv_affine[5];
+            rawx = raw_inv_affine.xx * i + raw_inv_affine.xy * j + raw_inv_affine.x0;
+            rawy = raw_inv_affine.yx * i + raw_inv_affine.yy * j + raw_inv_affine.y0;
             if (rawx < 0 || rawy < 0 || rawx >= w ||
                 rawy >= h || basex < 0 || basey < 0 || basex >= width || basey >= height) {
                 for (k = 0; k < 4; k++)
@@ -427,6 +471,12 @@ rsvg_art_affine_image (const GdkPixbuf * img, GdkPixbuf * intermediate,
             }
 
         }
+
+    /* Don't need cairo_surface_mark_dirty(intermediate) here since
+     * the only caller does further work and then calls that himself.
+     */
+
+    return TRUE;
 }
 
 static void
@@ -435,46 +485,59 @@ rsvg_filter_free_pair (gpointer value)
     RsvgFilterPrimitiveOutput *output;
 
     output = (RsvgFilterPrimitiveOutput *) value;
-    g_object_unref (G_OBJECT (output->result));
+    cairo_surface_destroy (output->surface);
     g_free (output);
 }
 
+static void
+rsvg_filter_context_free (RsvgFilterContext * ctx)
+{
+    if (!ctx)
+	return;
+
+    if (ctx->bg_surface)
+        cairo_surface_destroy (ctx->bg_surface);
+
+    g_free (ctx);
+}
+
 /**
- * rsvg_filter_render: Copy the source to the bg using a filter.
+ * rsvg_filter_render:
  * @self: a pointer to the filter to use
- * @source: a pointer to the source pixbuf
- * @bg: the background pixbuf
+ * @source: the a #cairo_surface_t of type %CAIRO_SURFACE_TYPE_IMAGE
  * @context: the context
  *
- * This function will create a context for itself, set up the coordinate systems
- * execute all its little primatives and then clean up its own mess
+ * Create a new surface applied the filter. This function will create
+ * a context for itself, set up the coordinate systems execute all its
+ * little primatives and then clean up its own mess.
+ * 
+ * Returns: (transfer full): a new #cairo_surface_t
  **/
-GdkPixbuf *
-rsvg_filter_render (RsvgFilter * self, GdkPixbuf * source,
-                    GdkPixbuf * bg, RsvgDrawingCtx * context, RsvgBbox * bounds, char *channelmap)
+cairo_surface_t *
+rsvg_filter_render (RsvgFilter *self,
+                    cairo_surface_t *source,
+                    RsvgDrawingCtx *context, 
+                    RsvgBbox *bounds, 
+                    char *channelmap)
 {
     RsvgFilterContext *ctx;
     RsvgFilterPrimitive *current;
     guint i;
-    GdkPixbuf *out;
+    cairo_surface_t *output;
 
+    g_return_val_if_fail (source != NULL, NULL);
+    g_return_val_if_fail (cairo_surface_get_type (source) == CAIRO_SURFACE_TYPE_IMAGE, NULL);
 
     ctx = g_new (RsvgFilterContext, 1);
     ctx->filter = self;
-    ctx->source = source;
-    ctx->bg = bg;
+    ctx->source_surface = source;
+    ctx->bg_surface = NULL;
     ctx->results = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, rsvg_filter_free_pair);
     ctx->ctx = context;
 
-    g_object_ref (G_OBJECT (source));
+    rsvg_filter_fix_coordinate_system (ctx, rsvg_current_state (context), bounds);
 
-    rsvg_filter_fix_coordinate_system (ctx, rsvg_state_current (context), *bounds);
-
-    ctx->lastresult.result = source;
-    ctx->lastresult.Rused = 1;
-    ctx->lastresult.Gused = 1;
-    ctx->lastresult.Bused = 1;
-    ctx->lastresult.Aused = 1;
+    ctx->lastresult.surface = cairo_surface_reference (source);
     ctx->lastresult.bounds = rsvg_filter_primitive_get_bounds (NULL, ctx);
 
     for (i = 0; i < 4; i++)
@@ -482,21 +545,21 @@ rsvg_filter_render (RsvgFilter * self, GdkPixbuf * source,
 
     for (i = 0; i < self->super.children->len; i++) {
         current = g_ptr_array_index (self->super.children, i);
-        if (!strncmp (current->super.type->str, "fe", 2))
+        if (RSVG_NODE_IS_FILTER_PRIMITIVE (&current->super))
             rsvg_filter_primitive_render (current, ctx);
     }
 
-    out = ctx->lastresult.result;
+    output = ctx->lastresult.surface;
 
     g_hash_table_destroy (ctx->results);
 
-    g_free (ctx);
+    rsvg_filter_context_free (ctx);
 
-    return out;
+    return output;
 }
 
 /**
- * rsvg_filter_store_result: Files a result into a context.
+ * rsvg_filter_store_result:
  * @name: The name of the result
  * @result: The pointer to the result
  * @ctx: the context that this was called in
@@ -509,67 +572,120 @@ rsvg_filter_store_output (GString * name, RsvgFilterPrimitiveOutput result, Rsvg
 {
     RsvgFilterPrimitiveOutput *store;
 
-    g_object_unref (G_OBJECT (ctx->lastresult.result));
+    cairo_surface_destroy (ctx->lastresult.surface);
 
     store = g_new (RsvgFilterPrimitiveOutput, 1);
     *store = result;
 
-    if (strcmp (name->str, "")) {
-        g_object_ref (G_OBJECT (result.result));        /* increments the references for the table */
+    if (name->str[0] != '\0') {
+        cairo_surface_reference (result.surface);        /* increments the references for the table */
         g_hash_table_insert (ctx->results, g_strdup (name->str), store);
     }
 
-    g_object_ref (G_OBJECT (result.result));    /* increments the references for the last result */
+    cairo_surface_reference (result.surface);    /* increments the references for the last result */
     ctx->lastresult = result;
 }
 
 static void
-rsvg_filter_store_result (GString * name, GdkPixbuf * result, RsvgFilterContext * ctx)
+rsvg_filter_store_result (GString * name,
+                          cairo_surface_t *surface,
+                          RsvgFilterContext * ctx)
 {
     RsvgFilterPrimitiveOutput output;
-    output.Rused = 1;
-    output.Gused = 1;
-    output.Bused = 1;
-    output.Aused = 1;
     output.bounds.x0 = 0;
     output.bounds.y0 = 0;
     output.bounds.x1 = ctx->width;
     output.bounds.y1 = ctx->height;
-    output.result = result;
+    output.surface = surface;
 
     rsvg_filter_store_output (name, output, ctx);
 }
 
-static GdkPixbuf *
-pixbuf_get_alpha (GdkPixbuf * pb, RsvgFilterContext * ctx)
+static cairo_surface_t *
+surface_get_alpha (cairo_surface_t *source,
+                   RsvgFilterContext * ctx)
 {
     guchar *data;
     guchar *pbdata;
-    GdkPixbuf *output;
-
     gsize i, pbsize;
+    cairo_surface_t *surface;
 
-    pbsize = gdk_pixbuf_get_width (pb) * gdk_pixbuf_get_height (pb);
+    if (source == NULL)
+        return NULL;
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8,
-                                       gdk_pixbuf_get_width (pb), gdk_pixbuf_get_height (pb));
+    cairo_surface_flush (source);
 
-    data = gdk_pixbuf_get_pixels (output);
-    pbdata = gdk_pixbuf_get_pixels (pb);
+    pbsize = cairo_image_surface_get_width (source) * 
+             cairo_image_surface_get_height (source);
+
+    surface = _rsvg_image_surface_new (cairo_image_surface_get_width (source),
+                                       cairo_image_surface_get_height (source));
+    if (surface == NULL)
+        return NULL;
 
+    data = cairo_image_surface_get_data (surface);
+    pbdata = cairo_image_surface_get_data (source);
+
+    /* FIXMEchpe: rewrite this into nested width, height loops */
     for (i = 0; i < pbsize; i++)
         data[i * 4 + ctx->channelmap[3]] = pbdata[i * 4 + ctx->channelmap[3]];
 
-    return output;
+    cairo_surface_mark_dirty (surface);
+    return surface;
 }
 
+static cairo_surface_t *
+rsvg_compile_bg (RsvgDrawingCtx * ctx)
+{
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
+    cairo_surface_t *surface;
+    cairo_t *cr;
+    GList *i;
+
+    surface = _rsvg_image_surface_new (render->width, render->height);
+    if (surface == NULL)
+        return NULL;
+
+    cr = cairo_create (surface);
+
+    for (i = g_list_last (render->cr_stack); i != NULL; i = g_list_previous (i)) {
+        cairo_t *draw = i->data;
+        gboolean nest = draw != render->initial_cr;
+        cairo_set_source_surface (cr, cairo_get_target (draw),
+                                  nest ? 0 : -render->offset_x,
+                                  nest ? 0 : -render->offset_y);
+        cairo_paint (cr);
+    }
+
+    cairo_destroy (cr);
+
+    return surface;
+}
+
+/**
+ * rsvg_filter_get_bg:
+ * 
+ * Returns: (transfer none) (nullable): a #cairo_surface_t, or %NULL
+ */
+static cairo_surface_t *
+rsvg_filter_get_bg (RsvgFilterContext * ctx)
+{
+    if (!ctx->bg_surface)
+        ctx->bg_surface = rsvg_compile_bg (ctx->ctx);
+
+    return ctx->bg_surface;
+}
+
+/* FIXMEchpe: proper return value and out param! */
 /**
- * rsvg_filter_get_in: Gets a pixbuf for a primative.
- * @name: The name of the pixbuf
+ * rsvg_filter_get_result:
+ * @name: The name of the surface
  * @ctx: the context that this was called in
  *
- * Returns a pointer to the result that the name refers to, a special
- * Pixbuf if the name is a special keyword or NULL if nothing was found
+ * Gets a surface for a primitive
+ *
+ * Returns: (nullable): a pointer to the result that the name refers to, a special
+ * surface if the name is a special keyword or %NULL if nothing was found
  **/
 static RsvgFilterPrimitiveOutput
 rsvg_filter_get_result (GString * name, RsvgFilterContext * ctx)
@@ -579,28 +695,22 @@ rsvg_filter_get_result (GString * name, RsvgFilterContext * ctx)
     output.bounds.x0 = output.bounds.x1 = output.bounds.y0 = output.bounds.y1 = 0;
 
     if (!strcmp (name->str, "SourceGraphic")) {
-        g_object_ref (G_OBJECT (ctx->source));
-        output.result = ctx->source;
-        output.Rused = output.Gused = output.Bused = output.Aused = 1;
+        output.surface = cairo_surface_reference (ctx->source_surface);
         return output;
     } else if (!strcmp (name->str, "BackgroundImage")) {
-        g_object_ref (G_OBJECT (ctx->bg));
-        output.result = ctx->bg;
-        output.Rused = output.Gused = output.Bused = output.Aused = 1;
+        output.surface = rsvg_filter_get_bg (ctx);
+        if (output.surface)
+            cairo_surface_reference (output.surface);
         return output;
-    } else if (!strcmp (name->str, "") || !strcmp (name->str, "none") || !name) {
-        g_object_ref (G_OBJECT (ctx->lastresult.result));
+    } else if (!strcmp (name->str, "") || !strcmp (name->str, "none")) {
         output = ctx->lastresult;
+        cairo_surface_reference (output.surface);
         return output;
     } else if (!strcmp (name->str, "SourceAlpha")) {
-        output.Rused = output.Gused = output.Bused = 0;
-        output.Aused = 1;
-        output.result = pixbuf_get_alpha (ctx->source, ctx);
+        output.surface = surface_get_alpha (ctx->source_surface, ctx);
         return output;
     } else if (!strcmp (name->str, "BackgroundAlpha")) {
-        output.Rused = output.Gused = output.Bused = 0;
-        output.Aused = 1;
-        output.result = pixbuf_get_alpha (ctx->bg, ctx);
+        output.surface = surface_get_alpha (rsvg_filter_get_bg (ctx), ctx);
         return output;
     }
 
